Bug 1481775 - Review Request: python-jep - Embed Python in Java
Summary: Review Request: python-jep - Embed Python in Java
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: ---
Assignee: Kevin Fenzi
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2017-08-15 16:46 UTC by Raphael Groner
Modified: 2018-12-04 13:54 UTC (History)
2 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed: 2017-09-28 19:57:31 UTC
kevin: fedora-review+


Attachments (Terms of Use)

Description Raphael Groner 2017-08-15 16:46:40 UTC
Spec URL: http://raphgro.fedorapeople.org//python-jep.spec
SRPM URL: http://raphgro.fedorapeople.org//python-jep-3.7.0-1.fc26.src.rpm

Description:
Java Embedded Python
JEP embeds CPython in Java through JNI and is safe to use in a
heavily threaded environment.

Some benefits of embedding CPython in a JVM:
    Using the native Python interpreter may be much faster than
    alternatives.
    Python is mature, well supported, and well documented.
    Access to high quality Python modules, both native CPython
    extensions and Python-based.
    Compilers and assorted Python tools are as mature as the
    language.
    Python is an interpreted language, enabling scripting of
    established Java code without requiring recompilation.
    Both Java and Python are cross platform, enabling deployment
    to different operating system.

Comment 1 Raphael Groner 2017-08-15 16:47:38 UTC
Task info: https://koji.fedoraproject.org/koji/taskinfo?taskID=21245207

Comment 2 Kevin Fenzi 2017-08-17 00:06:02 UTC
I'll review this. Look for a full review in the next few days...

Comment 3 Raphael Groner 2017-08-17 04:37:28 UTC
Kevin, thanks for your interest.
Note to myself: Review swap with bug #1481046.

Comment 4 Kevin Fenzi 2017-08-20 19:47:42 UTC
1. There's 2 jar files in the tests directory that are provided from 
the upstream source. These should be removed before the build and any
tests that need them disabled. 

2. Should javadoc be made with this package? It's optional, but 
you might want to see if it's worthwhile. 
http://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation

3. IMHO The python-jep package should be python2-jep (if you are making 
the python2 version, which it looks like you are not?) 

4. The /usr/bin/jep file should be in both python2 and python3 
subpackages, or only the python3 one if you are only shipping that 
version. Right now someone could install python3-jep and have no 
bin to run. 

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Javadocs are placed in %{_javadocdir}/%{name} (no -%{version} symlink)
  Note: No javadoc subpackage present
  See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation
- Javadoc documentation files are generated and included in -javadoc
  subpackage
  Note: No javadoc subpackage present. Note: Javadocs are optional for
  Fedora versions >= 21
  See: https://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation
- Bundled jar/class files should be removed before build
  Note: Jar files in source (see attachment)
  See: http://fedoraproject.org/wiki/Packaging:Java#Pre-
  built_JAR_files_.2F_Other_bundled_software'


===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Development (unversioned) .so files in -devel subpackage, if present.
     Note: Unversioned so-files in private %_libdir subdirectory (see
     attachment). Verify they are not in ld path.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "zlib/libpng". 137 files have unknown
     license. Detailed output of licensecheck in /home/kevin/1481775
     -python-jep/licensecheck.txt
[!]: License file installed when any subpackage combination is installed.
[x]: Package does not own files or directories owned by other packages.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Useful -debuginfo package or justification otherwise.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Maven:
[-]: If package contains pom.xml files install it (including metadata) even
     when building with ant
[x]: Old add_to_maven_depmap macro is not being used

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[!]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in
     python3-jep , python-jep-debugsource
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

Java:
[ ]: Packages are noarch unless they use JNI
     Note: python-jep subpackage is not noarch. Please verify manually
[ ]: Package uses upstream build method (ant/maven/etc.)

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: python-jep-3.7.0-1.fc28.x86_64.rpm
          python3-jep-3.7.0-1.fc28.x86_64.rpm
          python-jep-debugsource-3.7.0-1.fc28.x86_64.rpm
          python-jep-3.7.0-1.fc28.src.rpm
python-jep.x86_64: E: no-binary
python-jep.x86_64: W: no-documentation
python-jep.x86_64: W: no-manual-page-for-binary jep
python3-jep.x86_64: W: dangling-relative-symlink /usr/share/doc/python3-jep/README.rst python3/README.rst
python3-jep.x86_64: E: script-without-shebang /usr/share/licenses/python3-jep/LICENSE
python-jep-debugsource.x86_64: W: no-documentation
python-jep-debugsource.x86_64: W: spurious-executable-perm /usr/src/debug/python-jep-3.7.0-1.fc28.x86_64/python3/src/jep/python/jep_object.c
python-jep.src:72: E: hardcoded-library-path in %{_prefix}/lib/jvm/java
python-jep.src:85: E: hardcoded-library-path in %{_prefix}/lib/jvm/java
python-jep.src:98: E: hardcoded-library-path in %{_prefix}/lib/jvm/java
4 packages and 0 specfiles checked; 5 errors, 91 warnings.




Rpmlint (installed packages)
----------------------------
sh: /usr/bin/python: No such file or directory
python-jep.x86_64: E: no-binary
python-jep.x86_64: W: no-documentation
python-jep.x86_64: W: no-manual-page-for-binary jep
python3-jep.x86_64: W: dangling-relative-symlink /usr/share/doc/python3-jep/README.rst python3/README.rst
python3-jep.x86_64: E: script-without-shebang /usr/share/licenses/python3-jep/LICENSE
python-jep-debugsource.x86_64: W: no-documentation
python-jep-debugsource.x86_64: W: spurious-executable-perm /usr/src/debug/python-jep-3.7.0-1.fc28.x86_64/python3/src/jep/python/jep_object.c
3 packages and 0 specfiles checked; 2 errors, 91 warnings.



Requires
--------
python-jep (rpmlib, GLIBC filtered):
    /bin/sh
    java-headless
    python3-jep

python3-jep (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libjvm.so()(64bit)
    libjvm.so(SUNWprivate_1.1)(64bit)
    libpthread.so.0()(64bit)
    libpython3.6m.so.1.0()(64bit)
    python(abi)
    rtld(GNU_HASH)

python-jep-debugsource (rpmlib, GLIBC filtered):



Provides
--------
python-jep:
    python-jep
    python-jep(x86-64)

python3-jep:
    python3-jep
    python3-jep(x86-64)
    python3.6dist(jep)
    python3dist(jep)

python-jep-debugsource:
    python-jep-debugsource
    python-jep-debugsource(x86-64)



Unversioned so-files
--------------------
python3-jep: /usr/lib64/python3.6/site-packages/jep/jep.cpython-36m-x86_64-linux-gnu.so
python3-jep: /usr/lib64/python3.6/site-packages/jep/libjep.so

Source checksums
----------------
https://github.com/ninia/jep/archive/v3.7.0.tar.gz :
  CHECKSUM(SHA256) this package     : d2f57b63b025b0df1fb3a27ee94e7e98b2223a64454d579507e0312a4da7f252
  CHECKSUM(SHA256) upstream package : d2f57b63b025b0df1fb3a27ee94e7e98b2223a64454d579507e0312a4da7f252


Jar and class files in source
-----------------------------
./python-jep-3.7.0/python3/tests/lib/sqlitejdbc-v056.jar
./python-jep-3.7.0/python3/tests/lib/fakenetty.jar


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1481775
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Shell-api, Generic, Java, C/C++
Disabled plugins: fonts, SugarActivity, Ocaml, Haskell, Perl, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Comment 5 Raphael Groner 2017-09-02 15:54:17 UTC
SPEC: https://raphgro.fedorapeople.org/review/py/jep/python-jep.spec
SRPM: https://raphgro.fedorapeople.org/review/py/jep/python-jep-3.7.0-2.fc26.src.rpm

%changelog
* Sat Sep 02 2017 Raphael Groner <projects.rg@smart.ms> - 3.7.0-2
- drop precompiled jar files
- be more verbose about tests
- add javadoc subpackage
- move interpreter script into python3 subpackage
- add release_notes folder to documentation
- handle readme file properly

Task info: https://koji.fedoraproject.org/koji/taskinfo?taskID=21618562


(In reply to Kevin Fenzi from comment #4)
> 1. There's 2 jar files in the tests directory that are provided from 
> the upstream source. These should be removed before the build and any
> tests that need them disabled. 

Fixed. Tests with unmet dependencies are automatically skipped. The URL [1] from sources gives me 404. Other tests can work only with python built for debug purpose what's not the case in Fedora.

[1] http://www.zentus.com/sqlitejdbc/

> 2. Should javadoc be made with this package? It's optional, but 
> you might want to see if it's worthwhile. 
> http://fedoraproject.org/wiki/Packaging:Java#Javadoc_installation

Fixed.

> 3. IMHO The python-jep package should be python2-jep (if you are making 
> the python2 version, which it looks like you are not?) 
> 
> 4. The /usr/bin/jep file should be in both python2 and python3 
> subpackages, or only the python3 one if you are only shipping that 
> version. Right now someone could install python3-jep and have no 
> bin to run. 

Yeah, not worth an extra package for the (optional) interpreter.

P.S. Sorry for the long delay!

Comment 6 Kevin Fenzi 2017-09-16 18:24:06 UTC
Sorry for my delay here. 

Everything looks good. This package is APPROVED.

Comment 7 Gwyn Ciesla 2017-09-18 11:41:42 UTC
(fedrepo-req-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-jep

Comment 8 Fedora Update System 2017-09-18 22:51:22 UTC
python-jep-3.7.0-2.fc27 has been submitted as an update to Fedora 27. https://bodhi.fedoraproject.org/updates/FEDORA-2017-ea6bd49b49

Comment 9 Fedora Update System 2017-09-18 22:51:30 UTC
python-jep-3.7.0-2.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-b728aefab0

Comment 10 Fedora Update System 2017-09-19 23:28:58 UTC
python-jep-3.7.0-2.fc27 has been pushed to the Fedora 27 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-ea6bd49b49

Comment 11 Fedora Update System 2017-09-20 00:23:22 UTC
python-jep-3.7.0-2.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-b728aefab0

Comment 12 Fedora Update System 2017-09-28 19:57:31 UTC
python-jep-3.7.0-2.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.

Comment 13 Fedora Update System 2017-09-30 06:40:31 UTC
python-jep-3.7.0-2.fc27 has been pushed to the Fedora 27 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.